Subject: bug#1432 closed by "Juanma Barranquero" <[email-masked]> ()

From: [email-masked] (Emacs bug Tracking System)

This is an automatic notification regarding your bug report
which was filed against the emacs package:

#1432: Sorting buffers with ibuffer

It has been closed by "Juanma Barranquero" <[email-masked]>.

Their explanation is attached below along with your original report.
If this explanation is unsatisfactory and you have not received a
better one in a separate message then please contact "Juanma Barranquero" <[email-masked]> by
replying to this email.

-- 
1432: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=1432
Emacs Bug Tracking System
Contact [email-masked] with problems
>From [email-masked] Thu Dec  4 16:03:11 2008
Date: Fri, 5 Dec 2008 01:03:07 +0100
From: "Juanma Barranquero" <[email-masked]>
To: [email-masked]
Subject: 

Fixed.

http://cvs.savannah.gnu.org/viewcvs/emacs/lisp/ibuffer.el?cvsroot=emacs&r1=1.110&r2=1.111

>From [email-masked] Wed Nov 26 02:28:43 2008
Date: Wed, 26 Nov 2008 11:28:39 +0100
From: "Juanma Barranquero" <[email-masked]>
To: z0d <[email-masked]>
Subject: Re: Sorting buffers with ibuffer
Cc: [email-masked], [email-masked]

Package: emacs
Severity: minor
X-Debbugs-CC: [email-masked]

On Wed, Nov 26, 2008 at 04:29, z0d <[email-masked]> wrote:

> shell: emacs -q .emacs .ssh/config .Emacs-lisp/init-lisp.el
>
> M-: (setq-default ibuffer-default-sorting-mode 'major-mode) <RET>
> M-x ibuffer <RET>
>
> produces:
>
>  MR Name                    Size Mode             Filename/Process
>  -- ----                    ---- ----             ----------------
> [ Default ]
>    asdf-skeleton.el        1052 Emacs-Lisp       ~/.Emacs-Lisp/asdf-
> skeleton.el
>    config                   488 Conf[Space]      ~/.ssh/config
>    .emacs                 13170 Emacs-Lisp       ~/.emacs
>    *scratch*                191 Lisp Interaction
>  *  *Messages*               142 Fundamental
>  % *GNU Emacs*              744 Fundamental
>
>    6 buffers              15787                  3 files, no
> processes

You're right.

What's happening is that, in fact, ibuffer is not sorting at all,
because there's a variable ibuffer-sorting-functions-alist that is
null at that point. That variable is initialized by code in
ibuf-ext.el; defaulting to 'recency works because that sorting order
is special-cased in ibuffer.el.

You can workaround the issue by making sure ibuf-ext is loaded, for example:

  emacs -q -l ibuf-ext .emacs .ssh/config .Emacs-lisp/init-lisp.el

but I think ibuffer should take care that the sorting functions' alist
is properly stuffed.

John, I've considered the attached patch, which checks in
ibuffer-sort-bufferlist. The alternative I see is to require 'ibuf-ext
in `ibuffer-mode' if the user modified `ibuffer-default-sorting-mode',
like

  (set (make-local-variable 'ibuffer-sorting-mode)
       ibuffer-default-sorting-mode)
  (unless (eq ibuffer-sorting-mode 'recency)
    (require 'ibuf-ext))

Are you OK with one of these changes?

  Juanma

Index: lisp/ibuffer.el
===================================================================
RCS file: /sources/emacs/emacs/lisp/ibuffer.el,v
retrieving revision 1.110
diff -u -2 -r1.110 ibuffer.el
--- lisp/ibuffer.el	8 Oct 2008 05:02:09 -0000	1.110
+++ lisp/ibuffer.el	26 Nov 2008 09:56:30 -0000
@@ -2192,4 +2192,6 @@

 (defun ibuffer-sort-bufferlist (bmarklist)
+  (unless ibuffer-sorting-functions-alist
+    (require 'ibuf-ext))
   (let* ((sortdat (assq ibuffer-sorting-mode
 			ibuffer-sorting-functions-alist))